const express = require('express');
const multer = require('multer');
const path = require('path');
const moment = require('moment');
const connection = require('./db');
const languageMessages = require('./language_messages');
const compressing = require('compressing');
const {fetchUserData,getCurrentTimeInTimeZone} = require("./function_app");
const { request } = require('http');


const deleteLocalPostByDays = async (request, response) => {
    try {
        const selectDays = "SELECT post_disappear_delete_day FROM admin_manage_master WHERE delete_flag = 0";
        // const selectDaysResult = await connection.query(selectDays);
        await connection.query(selectDays,async(selectDaysError,selectDaysResult)=>{
            if (selectDaysResult.length > 0) {
                const post_disappear_delete_day = selectDaysResult[0].post_disappear_delete_day;
                const delete_by = 2;
                const delete_flag = 1;
    
                const selectPost = "SELECT post_id FROM post_master WHERE delete_flag = 0 AND post_type = 0 AND createtime <= DATE_SUB(NOW(), INTERVAL ? DAY)";
                // const selectPostResult = await connection.query(selectPost, [post_disappear_delete_day]);
                await connection.query(selectPost, [post_disappear_delete_day],async(selectPostError,selectPostResult)=>{
                    if (selectPostResult.length > 0) {
                        for (const data of selectPostResult) {
                            const post_id = data.post_id;
        
                            const deleteLocal = "UPDATE post_master SET delete_by = ?, delete_flag = ?, updatetime = NOW() WHERE post_id = ? and post_type=0";
                            await connection.query(deleteLocal, [delete_by, delete_flag, post_id]);
                        }
                    }
                    return;
                    // return response.send(200).json({ success: true, msg: languageMessages.postDeleteSuccessfully });
                    // return response.status(200).json({ success: true });
                });
                    
            } else {
                return;
                // return response.status(200).json({ success: true, msg: languageMessages.postDeleteSuccessfully });
                // return response.status(200).json({ success: true });
            }
        });
     
    } catch (error) {
        return;
        // return response.status(500).json({ success: false, msg: languageMessages.internalServerError, error });
    }
};





const deleteTopPostByDays = async (request, response) => {
    try {
        const selectDaysQuery = "SELECT top_post_disappear_delete_day FROM admin_manage_master WHERE delete_flag = 0";
        // const selectDaysResult = await connection.query(selectDaysQuery);

        await connection.query(selectDaysQuery,async(selectDaysQueryError,selectDaysResult)=>{
            if (selectDaysResult.length > 0) {
                const topPostDeleteDay = selectDaysResult[0].top_post_disappear_delete_day;
                const deleteBy = 2;
                const deleteFlag = 1;
    
                // Select posts that are older than topPostDeleteDay days
                const selectPostQuery = "SELECT post_id FROM post_master WHERE delete_flag = 0 AND post_type = 1 AND createtime <= DATE_SUB(NOW(), INTERVAL ? DAY)";
                // const selectPostResult = await connection.query(selectPostQuery, [topPostDeleteDay]);
                await connection.query(selectPostQuery, [topPostDeleteDay],async(selectPostQueryError,selectPostResult)=>{
                    if (selectPostResult.length > 0) {
                        for (const post of selectPostResult) {
                            const postId = post.post_id;
        
                            // Update the delete flag and delete_by for the selected posts
                            const deletePostQuery = "UPDATE post_master SET delete_by = ?, delete_flag = ?, updatetime = NOW() WHERE post_id = ? AND post_type = 1";
                            await connection.query(deletePostQuery, [deleteBy, deleteFlag, postId]);
                        }
                        return;
                        // return response.status(200).json({ success: true, msg: languageMessages.postDeleteSuccessfully,key:1});
                    } else {
                        return;
                        // return response.status(200).json({ success: true, msg: languageMessages.postDeleteSuccessfully,key:2});
                    }
                });
              
            } else {

                return;
                // return response.status(200).json({ success: true, msg: languageMessages.postDeleteSuccessfully,key:3});
            }
        });

      
    } catch (error) {
        console.error("Error:", error);
        return;
        // return response.status(500).json({ success: false, msg: languageMessages.internalServerError, error: error.message });
    }
};





// delete local user account by days start

const deleteLocalUserByDays = async (request, response) => {

    try {
        
        const selectDays = "SELECT guest_account_delete FROM admin_manage_master WHERE delete_flag=0";
        await connection.query(selectDays, async (selectDaysErr, selectDaysResult) => {
    
            if (selectDaysErr) {
                return;
                // return response.status(200).json({ success: false, msg: languageMessages.msgUserNotFound, selectDaysErr });
            }
    
            if (selectDaysResult.length > 0) {
    
                // delete post start
    
                var guest_account_delete = selectDaysResult[0].guest_account_delete;
                var delete_flag = 1;
    
                // selecting user start
                const selectUser = "SELECT user_id FROM user_master WHERE user_type=1 and delete_flag=0 AND updatetime <= DATE_SUB(NOW(), INTERVAL ? DAY)";
                await connection.query(selectUser, [guest_account_delete], async (selectUserErr, selectUserResult) => {
    
                    if (selectUserErr) {
                        return;
                        // return response.status(200).json({ success: false, msg: languageMessages.msgUserNotFound, selectUserErr });
                    }
    
                    if (selectUserResult.length > 0) {
    
                        for (const data of selectUserResult) {
    
                            var user_id = data.user_id;
    
                            const deleteLocal = `UPDATE user_master 
                                SET delete_flag = ?, updatetime = NOW()  
                                WHERE delete_flag = 0 AND user_id=?)`;
                
                            const deleteValues = [delete_flag,user_id];
                
                            await connection.query(deleteLocal, deleteValues, async (deleteLocalErr, deleteLocalResult) => {
                
                                if (deleteLocalErr) {
                                    return;
                                    // return response.status(200).json({ success: false, msg: languageMessages.msgUserNotFound, deleteLocalErr });
                                }           
                
                            })
                        }
    
                        return;
                        // return response.status(200).json({ success: true, msg: languageMessages.deleteAccount });
    
                    }
    
                })
    
                // selecting user end
            
            }
    
        })

        
    } catch (error) {
        return;
        // return response.status(500).json({ success: false, msg: languageMessages.internalServerError, error });
    }
}




// delete local user account by days end


module.exports = {
    deleteLocalPostByDays,
    deleteTopPostByDays,
    deleteLocalUserByDays
}