const connection = require('./db');
const languageMessages = require('./language_messages');
const {cheakUseractiveDeactive} = require('./function_app_common');
const {getCurrentTimeInTimeZone} = require("./function_app");

const reportByUser = (request, response) => {
   
    try {
        const { user_id, post_id, post_type, reason } = request.body;
        if (!user_id || !post_id || !reason) {
            return response.json({ success: false, msg: languageMessages.allFieldsRequired, data: {} });
        }
        // check user exists or not

        const updatetime = getCurrentTimeInTimeZone();

        var sql1 = "SELECT user_id from user_master where delete_flag = 0 AND user_id = ?";
        var values = [user_id];
        connection.query(sql1, values,async (err, information) => {
            if (err) {
                return response.status(500).json({ success: false, msg: languageMessages.internalServerError, data: {} });
            }
            if (information.length <= 0) {
                return response.status(500).json({ success: false, msg: languageMessages.msgUserNotFound, data: {} });
            }
            var result = await cheakUseractiveDeactive(user_id);
            if(result[0].active_flag === 0 ){
                return response.status(200).json({ success: false, msg: languageMessages.accountdeactivated,active_status : 0 });
            }
            // User exists, proceed to insert report
            var insertSql = "INSERT into report_master(user_id,post_id,post_type,reason,createtime,updatetime) values (?, ?, ?, ?, ?,?)";
            connection.query(insertSql, [user_id, post_id, post_type, reason,updatetime,updatetime], (error, data) => {
                if (error) {
                    return response.status(500).json({ success: false, msg: languageMessages.reportunsuccessfully, data: {} });
                } else {
                    return response.status(200).json({ success: true, msg: languageMessages.reportsuccessfully, data: data });
                }
            });
        });
    } catch (error) {
        return response.status(500).json({ success : false, msg : languageMessages.internalServerError, data : {} });
    }
}

module.exports = {
    reportByUser
};