const express = require('express');
const cron = require('node-cron');
const {GetContent,GetAllAvatar,GetAdminMail,getAllContentUrl} = require('./get_all_content');
const {GetAllKeywords,AddKeywords,removeKeyword} = require('./keywords');
const {login,GuestLogin,editprofile,getProfile,deleteAccount,randomName,contectUs} = require('./vip_login');
const {AddAvatar} = require('./add_avatar');
const {LanguageChange,location} = require('./setting.js');
const {reportByUser} = require("./report.js")
const {CreatePost,
    upload,
    GetMyPost,
    postLike,
    postDislike,
    updatePost,
    DeletePost,
    GetAllPost,
    getSinglePostDetails,
    getPostCount,
    saveUnsave,
    getAllSavedPost,
    getAllLocalPost,getAllTopPost} = require('./all_post');

    const{
        deleteLocalPostByDays,
        deleteTopPostByDays,
        deleteLocalUserByDays
    } = require('./cron_jobs');

var router = express.Router();

router.get('/get_content',GetContent);
router.get('/get_profile',getProfile);
router.post('/vip_login',upload.none(),login);
router.post('/add_keyword',upload.none(),AddKeywords);
router.post('/guest_Login',upload.none(),GuestLogin);
router.post('/delete_account',upload.none(),deleteAccount);
router.get('/get_avatar',GetAllAvatar);
router.get('/get_all_post',GetAllPost);
router.get('/get_admin_mail',GetAdminMail);
router.post('/add_avatar',upload.none(),AddAvatar);
router.post('/like_post',upload.none(),postLike);
router.post('/dislike_post',upload.none(),postDislike);
router.post('/save_unsave',upload.none(),saveUnsave);
router.get('/get_keywords',GetAllKeywords);
router.get('/get_my_posts',GetMyPost);
router.get('/get_all_saved_post',getAllSavedPost);
router.post("/change_language",upload.none(),LanguageChange);
// router.post("/change_km_miles",upload.none(),changekmmiles);
router.post("/change_location",upload.none(),location);
router.post('/create_post', upload.array('files'), CreatePost);
router.post('/update_post', upload.array('files'), updatePost);
router.post("/delete_post",upload.none(),DeletePost);
router.post("/edit_profile",upload.fields([{ name: 'image'}]),editprofile);
router.get("/random_Name",randomName);
router.get("/get_singlepost_details",getSinglePostDetails);
router.post("/report_post",upload.none(),reportByUser);
router.post("/contect_us",upload.none(),contectUs);
router.post("/remove_keyword",upload.none(),removeKeyword);
router.get("/get_post_count",getPostCount);
router.get("/get_all_content_url",getAllContentUrl);
router.get("/get_all_local_post",getAllLocalPost);
router.get("/get_all_top_post",getAllTopPost);
router.post("/cron_job_delete_local_post_by_days",upload.none(),deleteLocalPostByDays);
router.post("/cron_job_delete_top_post_by_days",upload.none(),deleteTopPostByDays);
router.post("/cron_job_delete_guest_user_by_days",upload.none(),deleteLocalUserByDays);
cron.schedule('* * * * *', deleteLocalPostByDays);
cron.schedule('* * * * *', deleteTopPostByDays);
cron.schedule('0 * * * *', deleteLocalUserByDays);

module.exports = router;