const connection = require('./db');
const languageMessages = require('./language_messages');
const moment = require("moment");
const {fetchUserData,getCurrentTimeInTimeZone} = require("./function_app");
const { cheakUseractiveDeactive } = require('./function_app_common');


//  change language start

const LanguageChange = (request, response) => {
    const { user_id } = request.body;

    try {
        var sql = `SELECT language_id FROM user_master WHERE delete_flag = 0 AND user_id = ?`;
        connection.query(sql, [user_id], (err, result) => {
            if (err) {
                return response.status(500).json({ success: false,  msg: languageMessages.internalServerError, data: {} });
            } else {
                if (result.length > 0) { 
                    var language = result[0].language_id;
                    // const updatetime = moment().format("YYYY-MM-DD HH:mm:ss");
                    const updatetime = getCurrentTimeInTimeZone();
                    var updateSql, msg;
                    if (language === 0) {
                        updateSql = `UPDATE user_master SET language_id = 1, updatetime = ? WHERE user_id = ? AND delete_flag = 0`;
                        msg = "Language changed from English to Chinese.";
                    } else {
                        updateSql = `UPDATE user_master SET language_id = 0, updatetime = ? WHERE user_id = ? AND delete_flag = 0`;
                        msg = "Language changed from Chinese to English.";
                    }
                    connection.query(updateSql, [updatetime, user_id], async(updateErr, updateResult) => {
                        if (updateErr) {
                            return response.status(500).json({ success: false,  msg: languageMessages.internalServerError, data: {} });  
                        } else {
                            try {
                              
                                fetchUserData(user_id, (error, userDataArray) => {
                                    if (error) {
                                      console.error('Error fetching user data:', error);
                                      return;
                                    }
                                    return response.json({ success: true, msg: msg, data: userDataArray });
                                });
                                  
                               
                            } catch (getUserDetailsError) {
                                console.error("Error getting user details:", getUserDetailsError);
                                return res.status(500).json({ success: false, msg: languageMessages.internalServerError, 'key': '2', error: getUserDetailsError });
                            }
                            // return response.json({ success: true, msg: msg, data: updateResult });
                        }
                    });
                } else {
                    return response.status(404).json({ success: false, msg:languageMessages.msgDataNotFound });
                }
            }
        });
    } catch (error) {
        console.log("Error in language Change:", error);
        return response.status(500).json({ success: false, msg: languageMessages.internalServerError, data: {}});
    }
}

//  change language end


// convert location as permanent start

const location = (request, response) => {
    const { user_id,latitude,longitude,address,currect_location_permanent} = request.body;
    try {

        // // Check if user exists
        // var userSql = "SELECT user_id FROM user_master WHERE delete_flag = 0 AND user_id = ?";
        // var userValues = [user_id];
        // connection.query(userSql, userValues, async (userErr, userInformation) => {
        //     if (userErr) {
        //         return res.status(500).json({ success: false, msg: languageMessages.internalServerError, data: {} });
        //     }
        //     if (userInformation.length <= 0) {
        //         return res.status(500).json({ success: false, msg: languageMessages.msgUserNotFound, data: {} });
        //     } 
        //     var result = await cheakUseractiveDeactive(user_id);
        //     if(result[0].active_flag === 0 ){
        //         return res.status(200).json({ success: false, msg: languageMessages.accountdeactivated,active_status : 0 });
        //     }
    
        //     // Check if keyword exists
        // });


        

        var sql = `SELECT currect_location_permanent FROM user_master WHERE delete_flag = 0 AND user_id = ?`;
        connection.query(sql, [user_id], (err, result) => {
            if (err) {
                return response.status(500).json({ success: false,  msg: languageMessages.internalServerError, data: {}, error: err });
            } else {
                if (result.length > 0) { 
                    // var currect_location_permanent  = result[0].currect_location_permanent ;
                    // const updatetime = moment().format("YYYY-MM-DD HH:mm:ss");
                    const updatetime = getCurrentTimeInTimeZone();
                    var updateSql, msg;
                    // if (currect_location_permanent == 0) {
                        updateSql = `UPDATE user_master SET currect_location_permanent  = ?, updatetime = ?,latitude=?,longitude=?,address=?,current_location=?,current_lattitude=?,current_longitude=? WHERE user_id = ? AND delete_flag = 0`;
                      
                    connection.query(updateSql,[currect_location_permanent,updatetime,latitude,longitude,address,address,latitude,longitude,user_id], async (updateErr, updateResult) => {
                        if (updateErr) {
                            return response.status(500).json({ success: false, msg: languageMessages.internalServerError, data: {}, error: updateErr });  
                        } else {
                            try {
                                fetchUserData(user_id, (error, userDataArray) => {
                                    if (error) {
                                      console.error('Error fetching user data:', error);
                                      return;
                                    }
                                    return response.json({ success: true, msg: languageMessages.locationStatusUpdateSuccess, data: userDataArray });
                                });
                             
                            } catch (error) {
                                console.error("Error getting user details:", error);
                                return response.status(500).json({ success: false, msg: languageMessages.internalServerError, 'key': '2', error: error.message });
                            }
                        }
                    });
                } else {
                    return response.status(200).json({ success: true, msg: languageMessages.msgDataFound,data:'NA' });
                }
            }
        });
    } catch (error) {
        console.log("Error in currect_location_permanent Change : ", error);
        return response.status(500).json({ success: false, msg: languageMessages.internalServerError, error: error });
    }
}

// convert location as permanent start

module.exports = {
    LanguageChange,
    // changekmmiles,
    location
};
